////////////////////////////////////////////////////////////////////////
// delete_recording.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.delete_recording")

// <%pre>
#line 1 "delete_recording.ecpp"


#include <exception.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("delete_recording");

static const char* rawData = "\030\000\000\000I\000\000\000Z\000\000\000k\000\000\000r\000\000\000s\000\000\000<b>Delet"
  "e-Recording Request</b>\n<hr/>\nRecording: <br/>\nResult:    <br/>\nError:     \n<hr/>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("delete_recording " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string param = qparam.get< std::string >("param");
std::string async = qparam.get< std::string >("async");
  // </%args>

#line 17 "delete_recording.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 19 "delete_recording.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat<0> targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }
  RecordingsManagerPtr recordings = LiveRecordingsManager();
  const cRecording *recording = recordings->GetByMd5Hash(param);
  if (recording == nullptr) {
    esyslog("live: ERROR in delete_recording.ecpp, no recording with id %s found", param.c_str() );
    throw HtmlError(tr("Couldn't find recording or no recordings available"));
  }

  if (!cUser::CurrentUserHasRightTo(UR_DELRECS)) {
    esyslog("live: WARNING in delete_recording.ecpp, no permission to delete recording %s", recording->Name() );
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  }

  bool ajaxReq = !async.empty() && (parse_int<int>(async) != 0);
  std::string referrer;

  if (ajaxReq) {
    reply.setContentType( "application/xml" );
  }
  else {
    referrer = request.getHeader("Referer:");
  }

  RemoveRecordingTask task(param);
  LiveTaskManager().Execute(task);
  const char *result;
  if (task.Result()) {
    isyslog("live: INFO in delete_recording.ecpp, deleted recording with id %s name %s", param.c_str(), recording->Name() );
    result = "success";
  } else {
    esyslog("live: ERROR in delete_recording.ecpp, cannot delete recording with id %s name %s error %s", param.c_str(), recording->Name(), task.Error().c_str() );
    result = "error";
  }

  if (!ajaxReq) {
    if (!referrer.empty() && referrer.find("login") == std::string::npos) {
      return reply.redirect(referrer);
    }

  reply.out() << _tntChunks[0]; // <b>Delete-Recording Request</b>\n<hr/>\nRecording: 
#line 65 "delete_recording.ecpp"
  reply.sout() << ( recording->Name() );
  reply.out() << _tntChunks[1]; // <br/>\nResult:    
#line 66 "delete_recording.ecpp"
  reply.sout() << ( result );
  reply.out() << _tntChunks[2]; // <br/>\nError:     
#line 67 "delete_recording.ecpp"
  reply.sout() << ( !task.Error().empty() ? task.Error() : "—" );
  reply.out() << _tntChunks[3]; // \n<hr/>\n
#line 69 "delete_recording.ecpp"

  }
  else {

  // <& xmlresponse.ajax ...
  { 
#line 73 "delete_recording.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 73 "delete_recording.ecpp"
    _tnt_cq0.add( "error", (task.Error()));
#line 73 "delete_recording.ecpp"
    _tnt_cq0.add( "name", ("delete_recording"));
#line 73 "delete_recording.ecpp"
    _tnt_cq0.add( "pname", ("recording"));
#line 73 "delete_recording.ecpp"
    _tnt_cq0.add( "result", (task.Result()));
#line 73 "delete_recording.ecpp"
    _tnt_cq0.add( "value", (recording->Name()));
#line 73 "delete_recording.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ajax"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n
#line 74 "delete_recording.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
