////////////////////////////////////////////////////////////////////////
// remote.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.remote")

// <%pre>
#line 1 "remote.ecpp"


#include <grab.h>
#include <setup.h>
#include <tools.h>
#include <users.h>

#include <vdr/remote.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class remote_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        remote_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    remote_actions_type remote_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("remote");

static const char* rawData = "\214\001\000\000\215\001\000\000\373\001\000\000\006\002\000\000\t\002\000\000\365\017"
  "\000\000\333\020\000\000+\022\000\000_\022\000\000\224\022\000\000\307\022\000\000\365\022\000\000\245\023\000\000"
  "\005\024\000\000\257\024\000\000k\027\000\000\327\030\000\000\033\031\000\000_\031\000\000\235\031\000\000\334\031"
  "\000\000\034\032\000\000]\032\000\000\237\032\000\000\310\032\000\000\357\032\000\000\026\033\000\000>\033\000\000f"
  "\033\000\000\216\033\000\000\267\033\000\000\337\033\000\000\006\034\000\000M\034\000\000\225\034\000\000\327\034\000"
  "\000\015\035\000\000N\035\000\000\217\035\000\000:\036\000\000_\036\000\000\204\036\000\000\251\036\000\000\316\036"
  "\000\000\363\036\000\000\030\037\000\000=\037\000\000b\037\000\000\207\037\000\000\370\037\000\000\? \000\000\347 "
  "\000\000\354 \000\000D!\000\000{!\000\000\302!\000\000\201\"\000\000\343\"\000\000E#\000\000\251#\000\000\013$\000"
  "\000m$\000\000\321$\000\0006%\000\000\232%\000\000\000&\000\000d&\000\000\311&\000\000J'\000\000\312'\000\000K(\000"
  "\000\314(\000\000O)\000\000\331)\000\000\241*\000\000E+\000\000\317+\000\000t,\000\000&-\000\000\316-\000\000m.\000"
  "\000\320.\000\000T/\000\000\327/\000\000\1340\000\000\3400\000\000=1\000\000>1\000\000\?1\000\000q1\000\000{1\000\000"
  "\3731\000\000C2\000\000J3\000\000s3\000\000\2173\000\000\2213\000\000\2223\000\000\2413\000\000\n\n<html>\n  <head>\n"
  "  <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n  <title>VDR-Live - </title>\n  \n  \n "
  " <script type=\"text/javascript\"><!--\n  var newImg = null;\n  var imgsrc = \"\";\n  var osdAjax = null;\n  var osdT"
  "imeout = -1;\n  var interval = -1;\n  var clkTimer;\n\n  function changeScreenContent(){\n    var screenCon= document"
  ".getElementsByName('screenCon');\n    for ( var i=0; i < screenCon.length; i++){\n      if (screenCon[i].id == 'scree"
  "nCon_grab'){\n        if (screenCon[i].checked){\n          newImg = new Image();\n          StreamLoad();\n         "
  " ChangeInterval();\n          StreamLoad();\n          document.images.vdrlive.style.display= '';\n        } else {\n"
  "          window.clearInterval(interval);\n          document.images.vdrlive.style.display= 'none';\n          newImg"
  " = null;\n        }\n      } else if (screenCon[i].id == 'screenCon_osd'){\n        if (screenCon[i].checked){\n     "
  "     osdAjax= new Ajax('osd.xml', {method: 'get'});\n          osdAjax.lastUpd= -1;\n          osdAjax.addEvent('onCo"
  "mplete', function(text,xmlDoc){\n            try{\n              var upd = parseInt(text.match(/data-time=\"(\134d+)"
  "\"/)[1]);\n              if ( osdAjax.lastUpd != upd ){\n                $('osd').empty().setHTML(text);\n           "
  "     osdAjax.lastUpd = upd;\n                var sOsdItems= $$('#screenshot .osdItems');\n                var sSelect"
  "ed= $$('#screenshot .selected');\n                if (sOsdItems.length > 0 && sSelected.length > 0) sOsdItems[0].scro"
  "llTop= sSelected[0].offsetTop - 40;\n              }\n            } catch (e) {}\n            window.clearInterval(os"
  "dTimeout);\n            osdTimeout= window.setTimeout(\"OSDLoad()\",1000);\n          });\n          document.getElem"
  "entById('osd').style.display= '';\n\n          OSDLoad()\n        } else {\n          document.getElementById('osd')."
  "style.display= 'none';\n          osdAjax= null;\n        }\n      } else if (screenCon[i].id == 'screenCon_none'){\n"
  "        if (screenCon[i].checked) {\n          document.getElementById('screenshot').style.display= 'none';\n        "
  "  document.getElementById('remoteDiv').style.transform= 'scale(1.4)';\n          document.getElementById('remoteDiv')"
  ".style.transformOrigin= 'left top';\n        } else {\n          document.getElementById('screenshot').style.display="
  " '';\n          document.getElementById('remoteDiv').style.transform= '';\n          document.getElementById('remoteD"
  "iv').style.transformOrigin= '';\n        }\n                              }\n    }\n\n  }\n\n  function StreamLoad()"
  "\n  {\n    if (!newImg)\n      return;\n    uniq = new Date();\n    uniq = uniq.getTime();\n    document.images.vdrli"
  "ve.src=newImg.src;\n    newImg.src=imgsrc+\"\?\"+uniq;\n  }\n\n  function StreamInit()\n  {\n    document.getElements"
  "ByName('screenCon')[0].checked= true;\n    if (document.images.vdrlive)\n      imgsrc = document.images.vdrlive.src;"
  "\n    FillIntervals();\n    changeScreenContent();\n    $('osd').addEvents({\n        'click': function(ev){\n       "
  "     $clear(clkTimer);\n            clkTimer = (function(){\n              handleOSD(ev.target, false);\n            "
  "}).delay(200, this);\n        },\n        'dblclick': function(ev){\n            $clear(clkTimer);\n            handl"
  "eOSD(ev.target, true);\n        }\n    });\n  }\n\n  function ChangeInterval()\n  {\n    var element = document.getEl"
  "ementsByName('interval').item(0);\n    var timeout = element.value;\n    window.clearInterval(interval);\n    interva"
  "l = window.setInterval(\"StreamLoad()\", timeout);\n  }\n\n  function StreamEnd()\n  {\n    window.clearInterval(inte"
  "rval);\n  }\n\n  function OSDLoad(){\n    if (osdAjax)\n      osdAjax.request();\n  }\n  function selectLineOsd(elem,"
  "DonotLoadOSD) {\n    var hits= 0,\n      cur= elem,\n      keycode= ;\n    while (cur && cur.className.indexOf('selec"
  "ted') == -1 ) {\n      if (cur.className.indexOf('notSelectable') == -1) hits++;\n      cur= cur.previousSibling;\n  "
  "  };\n    if (!cur) {\n      hits= 0;\n      cur= elem;\n      keycode= ;\n      while (cur && cur.className.indexOf("
  "'selected') == -1 ){\n        if (cur.className.indexOf('notSelectable') == -1) hits++;\n        cur= cur.nextSibling"
  ";\n      };\n    }\n    KeyPress(keycode, DonotLoadOSD, hits);\n  }\n  function handleOSD(elem, doEnter){\n    switch"
  " (elem.className){\n    case 'osdButtonRed':\n      return KeyPress();\n    case 'osdButtonGreen':\n      return KeyP"
  "ress();\n    case 'osdButtonYellow':\n      return KeyPress();\n    case 'osdButtonBlue':\n      return KeyPress();\n"
  "    case 'osdTitle':\n      return KeyPress();\n    case '':\n      if (elem.parentNode.className == 'osdItem') {\n  "
  "      selectLineOsd(elem.parentNode,doEnter);\n        if (!doEnter) return false;\n        return KeyPress();\n     "
  " }\n      if (elem.parentNode.className == 'osdItem selected') {\n        return KeyPress();\n      }\n      return t"
  "rue;\n    case 'osdItem':\n      selectLineOsd(elem,doEnter);\n      if (!doEnter) return false;\n    case 'osdItem s"
  "elected':\n      return KeyPress();\n    }\n    return true;\n  }\n\n  function KeyPress(keycode,DonotLoadOSD=false,r"
  "epeat=1)\n  {\n    var req = new Ajax('keypress.xml', { method : 'post'});\n    if (!DonotLoadOSD && osdAjax)\n      "
  "req.addEvent('onComplete', OSDLoad);\n    req.request('keycode=' + keycode + '&async=1&repeat='+repeat);\n    return "
  "false;\n  }\n\n  function FillIntervals()\n  {\n    var element = document.getElementsByName('interval').item(0);\n  "
  "  if (!element)\n      return;\n    var items = new Array(1000, 2000, 5000);\n    element.options.length = items.leng"
  "th;\n    for (i = 0; i < items.length; ++i) {\n      element.options[i].value = items[i];\n      element.options[i].t"
  "ext = (items[i] / 1000) + \" s\";\n      if (items[i] == )\n        element.selectedIndex = i;\n    }\n  }\n\n  funct"
  "ion KeyboardInput(ev)\n  {\n// https://www.yavdr.org/documentation/0.7/yaVDR07_documentation.html#vdr -> Tastenbelegu"
  "ng\n// https://developer.mozilla.org/en-US/docs/Web/API/UI_Events/Keyboard_event_key_values\n    switch (ev.which){\n"
  "    case 120:                                // F9\n    case 9:  return KeyPress();   // VK_TAB The Horizontal Tab ke"
  "y,\n    case 27: return KeyPress();   // VK_ESCAPE The Esc (Escape) key\n    case 13: return KeyPress();     // VK_RE"
  "TURN Enter/Return\n    case 38: return KeyPress();     // VK_UP The up arrow key.\n    case 40: return KeyPress();   "
  "// VK_DOWN The down arrow key\n    case 37: return KeyPress();   // VK_LEFT The left arrow key.\n    case 39: return "
  "KeyPress();  // VK_RIGHT The right arrow key\n    case 112: return KeyPress();   // F1\n    case 113: return KeyPress"
  "(); // F2\n    case 114: return KeyPress(); // F3\n    case 115: return KeyPress();  // F4\n    case 116: return KeyP"
  "ress();  // F5\n    case 117: return KeyPress();  // F6\n    case 121: return KeyPress();  // F10\n    case 122: retu"
  "rn KeyPress(); // F11\n    case 123: return KeyPress(); // F12\n    case 33: return KeyPress(); // VK_PRIOR The Page "
  "Up (or PgUp) key.\n    case 34: return KeyPress(); // VK_NEXT The Page Down (or PgDn) key.\n    case 36: return KeyPr"
  "ess(); // VK_HOME The Home key (or Pos1)\n    case 35: return KeyPress(); // VK_END The End key\n    case 45: return "
  "KeyPress(); // VK_INSERT The Insert key, Ins\n    case 46: return KeyPress(); // VK_DELETE The Delete key, Del\n    c"
  "ase  8: return KeyPress(); // VK_BACK The Backspace key. This key is labeled Delete on Mac keyboards\n    }\n    if ("
  "ev.key.length == 1) {\n      switch (ev.key) {\n        case '0': return KeyPress();\n        case '1': return KeyPre"
  "ss();\n        case '2': return KeyPress();\n        case '3': return KeyPress();\n        case '4': return KeyPress("
  ");\n        case '5': return KeyPress();\n        case '6': return KeyPress();\n        case '7': return KeyPress();"
  "\n        case '8': return KeyPress();\n        case '9': return KeyPress();\n      }\n      let i_val = ev.key.charC"
  "odeAt(0);\n      if (i_val > 31 & i_val < 256) {\n        return KeyPress( | (i_val << 16));\n      }\n    }\n    ret"
  "urn true;\n  }\n  //--></script>\n  </head>\n  <body onload=\"StreamInit(); FillIntervals(); adjustHeader()\" onresiz"
  "e=\"adjustHeader()\" onunload=\"StreamEnd()\" onkeydown=\"return KeyboardInput(event);\">\n    \n    \n    <div class"
  "=\"inhalt\" id=\"remoteDiv\">\n      <div class=\"screenshot\" id=\"screenshot\">\n\n          <img src=\"screenshot."
  "jpg\" name=\"vdrlive\" />\n\n        <div id=\"osd\"></div>\n      </div>\n      <div>\n      <img src=\"\" width=\"1"
  "62\" height=\"378\" border=\"0\" usemap=\"#remote\" alt=\"\" />\n           <map name=\"remote\">\n          <area hr"
  "ef=\"#\" shape=\"circle\" coords=\"37,36,10\" alt=\"Power\" onclick=\"return KeyPress()\" />\n          <area href=\""
  "#\" shape=\"rect\" coords=\"27,60,59,75\" alt=\"1\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shap"
  "e=\"rect\" coords=\"64,59,98,75\" alt=\"2\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect"
  "\" coords=\"103,59,137,75\" alt=\"3\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect\" coo"
  "rds=\"25,82,60,98\" alt=\"4\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect\" coords=\"65"
  ",82,98,99\" alt=\"5\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect\" coords=\"103,83,137"
  ",99\" alt=\"6\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect\" coords=\"26,106,60,121\" "
  "alt=\"7\"  onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect\" coords=\"65,105,97,121\" alt="
  "\"8\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect\" coords=\"104,106,137,122\" alt=\"9"
  "\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"rect\" coords=\"66,128,98,144\" alt=\"0\" onc"
  "lick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"circle\" coords=\"37,157,13\" alt=\"Vol+\" onclick="
  "\"return KeyPress()\" title=\"&amp;lt;F12&amp;gt;\" />\n          <area href=\"#\" shape=\"circle\" coords=\"37,190,1"
  "3\" alt=\"Vol-\" onclick=\"return KeyPress()\" title=\"&amp;lt;F11&amp;gt;\" />\n          <area href=\"#\" shape=\"c"
  "ircle\" coords=\"125,157,13\" alt=\"P+\" onclick=\"return KeyPress()\" title=\"&amp;lt;PgUp&amp;gt;\" />\n          <"
  "area href=\"#\" shape=\"circle\" coords=\"125,190,13\" alt=\"P-\" onclick=\"return KeyPress()\" title=\"&amp;lt;PgDn&"
  "amp;gt;\" />\n          <area href=\"#\" shape=\"circle\" coords=\"81,174,8\" alt=\"Mute\" onclick=\"return KeyPress("
  ")\" title=\"&amp;lt;F10&amp;gt;\" />\n          <area href=\"#\" shape=\"circle\" coords=\"81,202,11\" alt=\"Record\""
  " onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"poly\" coords=\"39,215,29,227,30,235,39,236,51,"
  "222,49,215,43,213\" alt=\"Menu\" onclick=\"return KeyPress()\" title=\"&amp;lt;Tab&amp;gt;,&amp;lt;F9&amp;gt;\" />\n "
  "         <area href=\"#\" shape=\"poly\" coords=\"119,213,127,219,135,230,132,235,127,236,119,231,114,223,113,215\" a"
  "lt=\"Exit\" onclick=\"return KeyPress()\" title=\"&amp;lt;Esc&amp;gt;\" />\n          <area href=\"#\" shape=\"poly\""
  " coords=\"33,289,31,298,43,310,51,308,54,300,41,287\" alt=\"Subtitles\" onclick=\"return KeyPress()\" />\n          <"
  "area href=\"#\" shape=\"poly\" coords=\"131,289,133,298,122,310,112,308,110,300,122,287\" alt=\"Audio\" onclick=\"ret"
  "urn KeyPress()\" />\n          <area href=\"#\" shape=\"poly\" coords=\"58,230,70,223,82,223,91,223,105,231,96,240,87"
  ",237,78,236,69,240,66,241,58,232\" alt=\"Up\" onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"po"
  "ly\" coords=\"111,237,119,249,121,259,119,275,113,285,109,284,101,276,104,270,107,260,106,253,101,245\" alt=\"Right\""
  " onclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"poly\" coords=\"66,281,75,285,86,285,95,281,106"
  ",291,100,295,87,300,73,300,58,291,57,289,58,289\" alt=\"Down\" onclick=\"return KeyPress()\" />\n          <area href"
  "=\"#\" shape=\"poly\" coords=\"51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264,43,252,49,240\" alt=\"Left\" o"
  "nclick=\"return KeyPress()\" />\n          <area href=\"#\" shape=\"circle\" coords=\"81,261,17\" alt=\"Ok\" onclick="
  "\"return KeyPress()\" title=\"&amp;lt;Enter&amp;gt;\" />\n          <area href=\"#\" shape=\"rect\" coords=\"25,324,5"
  "2,339\" alt=\"Red\" onclick=\"return KeyPress()\" title=\"&amp;lt;F1&amp;gt;\" />\n          <area href=\"#\" shape="
  "\"rect\" coords=\"53,324,81,339\" alt=\"Green\" onclick=\"return KeyPress()\" title=\"&amp;lt;F2&amp;gt;\" />\n      "
  "    <area href=\"#\" shape=\"rect\" coords=\"83,324,109,339\" alt=\"Yellow\" onclick=\"return KeyPress()\" title=\"&a"
  "mp;lt;F3&amp;gt;\" />\n          <area href=\"#\" shape=\"rect\" coords=\"110,324,137,339\" alt=\"Blue\" onclick=\"re"
  "turn KeyPress()\" title=\"&amp;lt;F4&amp;gt;\" />\n           </map>\n      </div>\n    </div>\n  </body>\n</html>\n"
  "\n\n<form id=\"remote\"><span>\n<span class=\"label bold\">: </span>\n   <input type=\"radio\" name=\"screenCon\" id="
  "\"screenCon_grab\" onchange=\"changeScreenContent()\"/>&nbsp;<label for=\"screenCon_grab\">:</label> <select name=\"i"
  "nterval\" onchange=\"ChangeInterval()\"></select>\n <input type=\"radio\" name=\"screenCon\" id=\"screenCon_osd\" onc"
  "hange=\"changeScreenContent()\" />&nbsp;<label for=\"screenCon_osd\">OSD</label>\n <input type=\"radio\" name=\"scree"
  "nCon\" id=\"screenCon_none\" onchange=\"changeScreenContent()\" />&nbsp;<label for=\"screenCon_osd\"></label>\n<span "
  "class=\"sep\">&nbsp;</span>\n<span class=\"sep\">|</span>\n \n \n</span></form>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    remote_actions(*this, "remote_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel = qparam.get< int >("channel", ( -1));
  // </%args>

#line 17 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 20 "remote.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 23 "remote.ecpp"

if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat targetUrl("/login.html?redirect=");
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

  reply.out() << _tntChunks[0]; // \n
#line 30 "remote.ecpp"

  if (!cUser::CurrentUserHasRightTo(UR_USEREMOTE))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

  pageTitle = tr("Remote Control");

  // cChannel* Channel; (see %request above)
  if ( channel > 0 ) {
    LOCK_CHANNELS_READ;
    Channel = (cChannel *)Channels->GetByNumber( channel );
  }
  else {
    if (cDevice::CurrentChannel()) {
      LOCK_CHANNELS_READ;
      Channel = (cChannel *)Channels->GetByNumber(cDevice::CurrentChannel());
    }
    else {
      LOCK_CHANNELS_READ;
      Channel = (cChannel *)Channels->Get( Channels->GetNextNormal( -1 ) );
    }
  }
  if ( Channel == 0 )
    throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );


  // <& pageelems.doc_type ...
  { 
#line 55 "remote.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 55 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n<html>\n  <head>\n  <meta name="viewport" content="width=device-width, initial-scale=1" />\n  <title>VDR-Live - 
#line 59 "remote.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[2]; // </title>\n  
  // <& pageelems.stylesheets ...
  { 
#line 60 "remote.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 60 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n  
  // <& pageelems.ajax_js ...
  { 
#line 61 "remote.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 61 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n  <script type="text/javascript"><!--\n  var newImg = null;\n  var imgsrc = "";\n  var osdAjax = null;\n  var osdTimeout = -1;\n  var interval = -1;\n  var clkTimer;\n\n  function changeScreenContent(){\n    var screenCon= document.getElementsByName('screenCon');\n    for ( var i=0; i < screenCon.length; i++){\n      if (screenCon[i].id == 'screenCon_grab'){\n        if (screenCon[i].checked){\n          newImg = new Image();\n          StreamLoad();\n          ChangeInterval();\n          StreamLoad();\n          document.images.vdrlive.style.display= '';\n        } else {\n          window.clearInterval(interval);\n          document.images.vdrlive.style.display= 'none';\n          newImg = null;\n        }\n      } else if (screenCon[i].id == 'screenCon_osd'){\n        if (screenCon[i].checked){\n          osdAjax= new Ajax('osd.xml', {method: 'get'});\n          osdAjax.lastUpd= -1;\n          osdAjax.addEvent('onComplete', function(text,xmlDoc){\n            try{\n              var upd = parseInt(text.match(/data-time="(\134d+)"/)[1]);\n              if ( osdAjax.lastUpd != upd ){\n                $('osd').empty().setHTML(text);\n                osdAjax.lastUpd = upd;\n                var sOsdItems= $$('#screenshot .osdItems');\n                var sSelected= $$('#screenshot .selected');\n                if (sOsdItems.length > 0 && sSelected.length > 0) sOsdItems[0].scrollTop= sSelected[0].offsetTop - 40;\n              }\n            } catch (e) {}\n            window.clearInterval(osdTimeout);\n            osdTimeout= window.setTimeout("OSDLoad()",1000);\n          });\n          document.getElementById('osd').style.display= '';\n\n          OSDLoad()\n        } else {\n          document.getElementById('osd').style.display= 'none';\n          osdAjax= null;\n        }\n      } else if (screenCon[i].id == 'screenCon_none'){\n        if (screenCon[i].checked) {\n          document.getElementById('screenshot').style.display= 'none';\n          document.getElementById('remoteDiv').style.transform= 'scale(1.4)';\n          document.getElementById('remoteDiv').style.transformOrigin= 'left top';\n        } else {\n          document.getElementById('screenshot').style.display= '';\n          document.getElementById('remoteDiv').style.transform= '';\n          document.getElementById('remoteDiv').style.transformOrigin= '';\n        }\n                              }\n    }\n\n  }\n\n  function StreamLoad()\n  {\n    if (!newImg)\n      return;\n    uniq = new Date();\n    uniq = uniq.getTime();\n    document.images.vdrlive.src=newImg.src;\n    newImg.src=imgsrc+"\?"+uniq;\n  }\n\n  function StreamInit()\n  {\n    document.getElementsByName('screenCon')[0].checked= true;\n    if (document.images.vdrlive)\n      imgsrc = document.images.vdrlive.src;\n    FillIntervals();\n    changeScreenContent();\n    $('osd').addEvents({\n        'click': function(ev){\n            $clear(clkTimer);\n            clkTimer = (function(){\n              handleOSD(ev.target, false);\n            }).delay(200, this);\n        },\n        'dblclick': function(ev){\n            $clear(clkTimer);\n            handleOSD(ev.target, true);\n        }\n    });\n  }\n\n  function ChangeInterval()\n  {\n    var element = document.getElementsByName('interval').item(0);\n    var timeout = element.value;\n    window.clearInterval(interval);\n    interval = window.setInterval("StreamLoad()", timeout);\n  }\n\n  function StreamEnd()\n  {\n    window.clearInterval(interval);\n  }\n\n  function OSDLoad(){\n    if (osdAjax)\n      osdAjax.request();\n  }\n  function selectLineOsd(elem,DonotLoadOSD) {\n    var hits= 0,\n      cur= elem,\n      keycode= 
#line 176 "remote.ecpp"
  reply.sout() << ( kDown );
  reply.out() << _tntChunks[5]; // ;\n    while (cur && cur.className.indexOf('selected') == -1 ) {\n      if (cur.className.indexOf('notSelectable') == -1) hits++;\n      cur= cur.previousSibling;\n    };\n    if (!cur) {\n      hits= 0;\n      cur= elem;\n      keycode= 
#line 184 "remote.ecpp"
  reply.sout() << ( kUp );
  reply.out() << _tntChunks[6]; // ;\n      while (cur && cur.className.indexOf('selected') == -1 ){\n        if (cur.className.indexOf('notSelectable') == -1) hits++;\n        cur= cur.nextSibling;\n      };\n    }\n    KeyPress(keycode, DonotLoadOSD, hits);\n  }\n  function handleOSD(elem, doEnter){\n    switch (elem.className){\n    case 'osdButtonRed':\n      return KeyPress(
#line 195 "remote.ecpp"
  reply.sout() << ( kRed );
  reply.out() << _tntChunks[7]; // );\n    case 'osdButtonGreen':\n      return KeyPress(
#line 197 "remote.ecpp"
  reply.sout() << ( kGreen );
  reply.out() << _tntChunks[8]; // );\n    case 'osdButtonYellow':\n      return KeyPress(
#line 199 "remote.ecpp"
  reply.sout() << ( kYellow );
  reply.out() << _tntChunks[9]; // );\n    case 'osdButtonBlue':\n      return KeyPress(
#line 201 "remote.ecpp"
  reply.sout() << ( kBlue );
  reply.out() << _tntChunks[10]; // );\n    case 'osdTitle':\n      return KeyPress(
#line 203 "remote.ecpp"
  reply.sout() << ( kBack );
  reply.out() << _tntChunks[11]; // );\n    case '':\n      if (elem.parentNode.className == 'osdItem') {\n        selectLineOsd(elem.parentNode,doEnter);\n        if (!doEnter) return false;\n        return KeyPress(
#line 208 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << _tntChunks[12]; // );\n      }\n      if (elem.parentNode.className == 'osdItem selected') {\n        return KeyPress(
#line 211 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << _tntChunks[13]; // );\n      }\n      return true;\n    case 'osdItem':\n      selectLineOsd(elem,doEnter);\n      if (!doEnter) return false;\n    case 'osdItem selected':\n      return KeyPress(
#line 218 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << _tntChunks[14]; // );\n    }\n    return true;\n  }\n\n  function KeyPress(keycode,DonotLoadOSD=false,repeat=1)\n  {\n    var req = new Ajax('keypress.xml', { method : 'post'});\n    if (!DonotLoadOSD && osdAjax)\n      req.addEvent('onComplete', OSDLoad);\n    req.request('keycode=' + keycode + '&async=1&repeat='+repeat);\n    return false;\n  }\n\n  function FillIntervals()\n  {\n    var element = document.getElementsByName('interval').item(0);\n    if (!element)\n      return;\n    var items = new Array(1000, 2000, 5000);\n    element.options.length = items.length;\n    for (i = 0; i < items.length; ++i) {\n      element.options[i].value = items[i];\n      element.options[i].text = (items[i] / 1000) + " s";\n      if (items[i] == 
#line 242 "remote.ecpp"
  reply.sout() << ( cToSvInt(LiveSetup().GetScreenshotInterval() ) );
  reply.out() << _tntChunks[15]; // )\n        element.selectedIndex = i;\n    }\n  }\n\n  function KeyboardInput(ev)\n  {\n// https://www.yavdr.org/documentation/0.7/yaVDR07_documentation.html#vdr -> Tastenbelegung\n// https://developer.mozilla.org/en-US/docs/Web/API/UI_Events/Keyboard_event_key_values\n    switch (ev.which){\n    case 120:                                // F9\n    case 9:  return KeyPress(
#line 253 "remote.ecpp"
  reply.sout() << ( kMenu );
  reply.out() << _tntChunks[16]; // );   // VK_TAB The Horizontal Tab key,\n    case 27: return KeyPress(
#line 254 "remote.ecpp"
  reply.sout() << ( kBack );
  reply.out() << _tntChunks[17]; // );   // VK_ESCAPE The Esc (Escape) key\n    case 13: return KeyPress(
#line 255 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << _tntChunks[18]; // );     // VK_RETURN Enter/Return\n    case 38: return KeyPress(
#line 256 "remote.ecpp"
  reply.sout() << ( kUp );
  reply.out() << _tntChunks[19]; // );     // VK_UP The up arrow key.\n    case 40: return KeyPress(
#line 257 "remote.ecpp"
  reply.sout() << ( kDown );
  reply.out() << _tntChunks[20]; // );   // VK_DOWN The down arrow key\n    case 37: return KeyPress(
#line 258 "remote.ecpp"
  reply.sout() << ( kLeft );
  reply.out() << _tntChunks[21]; // );   // VK_LEFT The left arrow key.\n    case 39: return KeyPress(
#line 259 "remote.ecpp"
  reply.sout() << ( kRight );
  reply.out() << _tntChunks[22]; // );  // VK_RIGHT The right arrow key\n    case 112: return KeyPress(
#line 260 "remote.ecpp"
  reply.sout() << ( kRed );
  reply.out() << _tntChunks[23]; // );   // F1\n    case 113: return KeyPress(
#line 261 "remote.ecpp"
  reply.sout() << ( kGreen );
  reply.out() << _tntChunks[24]; // ); // F2\n    case 114: return KeyPress(
#line 262 "remote.ecpp"
  reply.sout() << ( kYellow );
  reply.out() << _tntChunks[25]; // ); // F3\n    case 115: return KeyPress(
#line 263 "remote.ecpp"
  reply.sout() << ( kBlue );
  reply.out() << _tntChunks[26]; // );  // F4\n    case 116: return KeyPress(
#line 264 "remote.ecpp"
  reply.sout() << ( kFastRew );
  reply.out() << _tntChunks[27]; // );  // F5\n    case 117: return KeyPress(
#line 265 "remote.ecpp"
  reply.sout() << ( kFastFwd );
  reply.out() << _tntChunks[28]; // );  // F6\n    case 121: return KeyPress(
#line 266 "remote.ecpp"
  reply.sout() << ( kMute );
  reply.out() << _tntChunks[29]; // );  // F10\n    case 122: return KeyPress(
#line 267 "remote.ecpp"
  reply.sout() << ( kVolDn );
  reply.out() << _tntChunks[30]; // ); // F11\n    case 123: return KeyPress(
#line 268 "remote.ecpp"
  reply.sout() << ( kVolUp );
  reply.out() << _tntChunks[31]; // ); // F12\n    case 33: return KeyPress(
#line 269 "remote.ecpp"
  reply.sout() << ( kChanUp );
  reply.out() << _tntChunks[32]; // ); // VK_PRIOR The Page Up (or PgUp) key.\n    case 34: return KeyPress(
#line 270 "remote.ecpp"
  reply.sout() << ( kChanDn );
  reply.out() << _tntChunks[33]; // ); // VK_NEXT The Page Down (or PgDn) key.\n    case 36: return KeyPress(
#line 271 "remote.ecpp"
  reply.sout() << ( cToSvInt(kKbd | (kfHome << 16) ) );
  reply.out() << _tntChunks[34]; // ); // VK_HOME The Home key (or Pos1)\n    case 35: return KeyPress(
#line 272 "remote.ecpp"
  reply.sout() << ( cToSvInt(kKbd | (kfEnd << 16) ) );
  reply.out() << _tntChunks[35]; // ); // VK_END The End key\n    case 45: return KeyPress(
#line 273 "remote.ecpp"
  reply.sout() << ( cToSvInt(kKbd | (kfIns << 16) ) );
  reply.out() << _tntChunks[36]; // ); // VK_INSERT The Insert key, Ins\n    case 46: return KeyPress(
#line 274 "remote.ecpp"
  reply.sout() << ( cToSvInt(kKbd | (kfDel << 16) ) );
  reply.out() << _tntChunks[37]; // ); // VK_DELETE The Delete key, Del\n    case  8: return KeyPress(
#line 275 "remote.ecpp"
  reply.sout() << ( cToSvInt(kKbd | (0x7F << 16) ) );
  reply.out() << _tntChunks[38]; // ); // VK_BACK The Backspace key. This key is labeled Delete on Mac keyboards\n    }\n    if (ev.key.length == 1) {\n      switch (ev.key) {\n        case '0': return KeyPress(
#line 279 "remote.ecpp"
  reply.sout() << ( k0 );
  reply.out() << _tntChunks[39]; // );\n        case '1': return KeyPress(
#line 280 "remote.ecpp"
  reply.sout() << ( k1 );
  reply.out() << _tntChunks[40]; // );\n        case '2': return KeyPress(
#line 281 "remote.ecpp"
  reply.sout() << ( k2 );
  reply.out() << _tntChunks[41]; // );\n        case '3': return KeyPress(
#line 282 "remote.ecpp"
  reply.sout() << ( k3 );
  reply.out() << _tntChunks[42]; // );\n        case '4': return KeyPress(
#line 283 "remote.ecpp"
  reply.sout() << ( k4 );
  reply.out() << _tntChunks[43]; // );\n        case '5': return KeyPress(
#line 284 "remote.ecpp"
  reply.sout() << ( k5 );
  reply.out() << _tntChunks[44]; // );\n        case '6': return KeyPress(
#line 285 "remote.ecpp"
  reply.sout() << ( k6 );
  reply.out() << _tntChunks[45]; // );\n        case '7': return KeyPress(
#line 286 "remote.ecpp"
  reply.sout() << ( k7 );
  reply.out() << _tntChunks[46]; // );\n        case '8': return KeyPress(
#line 287 "remote.ecpp"
  reply.sout() << ( k8 );
  reply.out() << _tntChunks[47]; // );\n        case '9': return KeyPress(
#line 288 "remote.ecpp"
  reply.sout() << ( k9 );
  reply.out() << _tntChunks[48]; // );\n      }\n      let i_val = ev.key.charCodeAt(0);\n      if (i_val > 31 & i_val < 256) {\n        return KeyPress(
#line 292 "remote.ecpp"
  reply.sout() << ( kKbd );
  reply.out() << _tntChunks[49]; //  | (i_val << 16));\n      }\n    }\n    return true;\n  }\n  //--></script>\n
#line 298 "remote.ecpp"
 reply.sout().imbue(std::locale());

  reply.out() << _tntChunks[50]; //   </head>\n  <body onload="StreamInit(); FillIntervals(); adjustHeader()" onresize="adjustHeader()" onunload="StreamEnd()" onkeydown="return KeyboardInput(event);">\n    
  // <& pageelems.logo ...
  { 
#line 301 "remote.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 301 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[51]; // \n    
  // <& menu ...
  { 
#line 302 "remote.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 302 "remote.ecpp"
    _tnt_cq4.add( "active", "remote");
#line 302 "remote.ecpp"
    _tnt_cq4.add( "component", ("remote.remote_actions"));
#line 302 "remote.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[52]; // \n    <div class="inhalt" id="remoteDiv">\n      <div class="screenshot" id="screenshot">\n
#line 305 "remote.ecpp"
        if (LiveGrabImageManager().CanGrab()) {  
  reply.out() << _tntChunks[53]; // \n          <img src="screenshot.jpg" name="vdrlive" />\n
#line 307 "remote.ecpp"
        }                      
  reply.out() << _tntChunks[54]; // \n        <div id="osd"></div>\n      </div>\n      <div>\n      <img src="
#line 311 "remote.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "remotecontrol.jpg") );
  reply.out() << _tntChunks[55]; // " width="162" height="378" border="0" usemap="#remote" alt="" />\n           <map name="remote">\n          <area href="#" shape="circle" coords="37,36,10" alt="Power" onclick="return KeyPress(
#line 313 "remote.ecpp"
  reply.sout() << ( kPower );
  reply.out() << _tntChunks[56]; // )" />\n          <area href="#" shape="rect" coords="27,60,59,75" alt="1" onclick="return KeyPress(
#line 314 "remote.ecpp"
  reply.sout() << ( k1 );
  reply.out() << _tntChunks[57]; // )" />\n          <area href="#" shape="rect" coords="64,59,98,75" alt="2" onclick="return KeyPress(
#line 315 "remote.ecpp"
  reply.sout() << ( k2 );
  reply.out() << _tntChunks[58]; // )" />\n          <area href="#" shape="rect" coords="103,59,137,75" alt="3" onclick="return KeyPress(
#line 316 "remote.ecpp"
  reply.sout() << ( k3 );
  reply.out() << _tntChunks[59]; // )" />\n          <area href="#" shape="rect" coords="25,82,60,98" alt="4" onclick="return KeyPress(
#line 317 "remote.ecpp"
  reply.sout() << ( k4 );
  reply.out() << _tntChunks[60]; // )" />\n          <area href="#" shape="rect" coords="65,82,98,99" alt="5" onclick="return KeyPress(
#line 318 "remote.ecpp"
  reply.sout() << ( k5 );
  reply.out() << _tntChunks[61]; // )" />\n          <area href="#" shape="rect" coords="103,83,137,99" alt="6" onclick="return KeyPress(
#line 319 "remote.ecpp"
  reply.sout() << ( k6 );
  reply.out() << _tntChunks[62]; // )" />\n          <area href="#" shape="rect" coords="26,106,60,121" alt="7"  onclick="return KeyPress(
#line 320 "remote.ecpp"
  reply.sout() << ( k7 );
  reply.out() << _tntChunks[63]; // )" />\n          <area href="#" shape="rect" coords="65,105,97,121" alt="8" onclick="return KeyPress(
#line 321 "remote.ecpp"
  reply.sout() << ( k8 );
  reply.out() << _tntChunks[64]; // )" />\n          <area href="#" shape="rect" coords="104,106,137,122" alt="9" onclick="return KeyPress(
#line 322 "remote.ecpp"
  reply.sout() << ( k9 );
  reply.out() << _tntChunks[65]; // )" />\n          <area href="#" shape="rect" coords="66,128,98,144" alt="0" onclick="return KeyPress(
#line 323 "remote.ecpp"
  reply.sout() << ( k0 );
  reply.out() << _tntChunks[66]; // )" />\n          <area href="#" shape="circle" coords="37,157,13" alt="Vol+" onclick="return KeyPress(
#line 324 "remote.ecpp"
  reply.sout() << ( kVolUp );
  reply.out() << _tntChunks[67]; // )" title="&amp;lt;F12&amp;gt;" />\n          <area href="#" shape="circle" coords="37,190,13" alt="Vol-" onclick="return KeyPress(
#line 325 "remote.ecpp"
  reply.sout() << ( kVolDn );
  reply.out() << _tntChunks[68]; // )" title="&amp;lt;F11&amp;gt;" />\n          <area href="#" shape="circle" coords="125,157,13" alt="P+" onclick="return KeyPress(
#line 326 "remote.ecpp"
  reply.sout() << ( kChanUp );
  reply.out() << _tntChunks[69]; // )" title="&amp;lt;PgUp&amp;gt;" />\n          <area href="#" shape="circle" coords="125,190,13" alt="P-" onclick="return KeyPress(
#line 327 "remote.ecpp"
  reply.sout() << ( kChanDn );
  reply.out() << _tntChunks[70]; // )" title="&amp;lt;PgDn&amp;gt;" />\n          <area href="#" shape="circle" coords="81,174,8" alt="Mute" onclick="return KeyPress(
#line 328 "remote.ecpp"
  reply.sout() << ( kMute );
  reply.out() << _tntChunks[71]; // )" title="&amp;lt;F10&amp;gt;" />\n          <area href="#" shape="circle" coords="81,202,11" alt="Record" onclick="return KeyPress(
#line 329 "remote.ecpp"
  reply.sout() << ( kRecord );
  reply.out() << _tntChunks[72]; // )" />\n          <area href="#" shape="poly" coords="39,215,29,227,30,235,39,236,51,222,49,215,43,213" alt="Menu" onclick="return KeyPress(
#line 330 "remote.ecpp"
  reply.sout() << ( kMenu );
  reply.out() << _tntChunks[73]; // )" title="&amp;lt;Tab&amp;gt;,&amp;lt;F9&amp;gt;" />\n          <area href="#" shape="poly" coords="119,213,127,219,135,230,132,235,127,236,119,231,114,223,113,215" alt="Exit" onclick="return KeyPress(
#line 331 "remote.ecpp"
  reply.sout() << ( kBack );
  reply.out() << _tntChunks[74]; // )" title="&amp;lt;Esc&amp;gt;" />\n          <area href="#" shape="poly" coords="33,289,31,298,43,310,51,308,54,300,41,287" alt="Subtitles" onclick="return KeyPress(
#line 332 "remote.ecpp"
  reply.sout() << ( kSubtitles );
  reply.out() << _tntChunks[75]; // )" />\n          <area href="#" shape="poly" coords="131,289,133,298,122,310,112,308,110,300,122,287" alt="Audio" onclick="return KeyPress(
#line 333 "remote.ecpp"
  reply.sout() << ( kAudio );
  reply.out() << _tntChunks[76]; // )" />\n          <area href="#" shape="poly" coords="58,230,70,223,82,223,91,223,105,231,96,240,87,237,78,236,69,240,66,241,58,232" alt="Up" onclick="return KeyPress(
#line 334 "remote.ecpp"
  reply.sout() << ( kUp );
  reply.out() << _tntChunks[77]; // )" />\n          <area href="#" shape="poly" coords="111,237,119,249,121,259,119,275,113,285,109,284,101,276,104,270,107,260,106,253,101,245" alt="Right" onclick="return KeyPress(
#line 335 "remote.ecpp"
  reply.sout() << ( kRight );
  reply.out() << _tntChunks[78]; // )" />\n          <area href="#" shape="poly" coords="66,281,75,285,86,285,95,281,106,291,100,295,87,300,73,300,58,291,57,289,58,289" alt="Down" onclick="return KeyPress(
#line 336 "remote.ecpp"
  reply.sout() << ( kDown );
  reply.out() << _tntChunks[79]; // )" />\n          <area href="#" shape="poly" coords="51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264,43,252,49,240" alt="Left" onclick="return KeyPress(
#line 337 "remote.ecpp"
  reply.sout() << ( kLeft );
  reply.out() << _tntChunks[80]; // )" />\n          <area href="#" shape="circle" coords="81,261,17" alt="Ok" onclick="return KeyPress(
#line 338 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << _tntChunks[81]; // )" title="&amp;lt;Enter&amp;gt;" />\n          <area href="#" shape="rect" coords="25,324,52,339" alt="Red" onclick="return KeyPress(
#line 339 "remote.ecpp"
  reply.sout() << ( kRed );
  reply.out() << _tntChunks[82]; // )" title="&amp;lt;F1&amp;gt;" />\n          <area href="#" shape="rect" coords="53,324,81,339" alt="Green" onclick="return KeyPress(
#line 340 "remote.ecpp"
  reply.sout() << ( kGreen );
  reply.out() << _tntChunks[83]; // )" title="&amp;lt;F2&amp;gt;" />\n          <area href="#" shape="rect" coords="83,324,109,339" alt="Yellow" onclick="return KeyPress(
#line 341 "remote.ecpp"
  reply.sout() << ( kYellow );
  reply.out() << _tntChunks[84]; // )" title="&amp;lt;F3&amp;gt;" />\n          <area href="#" shape="rect" coords="110,324,137,339" alt="Blue" onclick="return KeyPress(
#line 342 "remote.ecpp"
  reply.sout() << ( kBlue );
  reply.out() << _tntChunks[85]; // )" title="&amp;lt;F4&amp;gt;" />\n           </map>\n      </div>\n    </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[86]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[87]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::remote_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote::remote_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 17 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 20 "remote.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[88]; // <form id="remote"><span>\n<span class="label bold">
#line 352 "remote.ecpp"
  reply.sout() << ( tr("Selection") );
  reply.out() << _tntChunks[89]; // : </span>\n
#line 353 "remote.ecpp"
  if ( LiveGrabImageManager().CanGrab()) {

  reply.out() << _tntChunks[90]; //    <input type="radio" name="screenCon" id="screenCon_grab" onchange="changeScreenContent()"/>&nbsp;<label for="screenCon_grab">
#line 354 "remote.ecpp"
  reply.sout() << ( tr("Snapshot interval") );
  reply.out() << _tntChunks[91]; // :</label> <select name="interval" onchange="ChangeInterval()"></select>\n
#line 355 "remote.ecpp"
 }

  reply.out() << _tntChunks[92]; //  <input type="radio" name="screenCon" id="screenCon_osd" onchange="changeScreenContent()" />&nbsp;<label for="screenCon_osd">OSD</label>\n <input type="radio" name="screenCon" id="screenCon_none" onchange="changeScreenContent()" />&nbsp;<label for="screenCon_osd">
#line 357 "remote.ecpp"
  reply.sout() << ( tr("Stop") );
  reply.out() << _tntChunks[93]; // </label>\n<span class="sep">&nbsp;</span>\n
#line 359 "remote.ecpp"
 if (Channel) {

  reply.out() << _tntChunks[94]; // <span class="sep">|</span>\n 
  // <& pageelems.hls_channel ...
  { 
#line 361 "remote.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 361 "remote.ecpp"
    _tnt_cq5.add( "channelId", (Channel->GetChannelID()));
#line 361 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[95]; // \n 
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 362 "remote.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 362 "remote.ecpp"
    _tnt_cq6.add( "channelId", (Channel->GetChannelID()));
#line 362 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[96]; // \n
#line 363 "remote.ecpp"
 }

  reply.out() << _tntChunks[97]; // </span></form>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
