////////////////////////////////////////////////////////////////////////
// stream.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.stream")

// <%pre>
#line 1 "stream.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <ffmpeg.h>
#include <tools.h>
#include <epg_events.h>
#include <recman.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class recording_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recording_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
    recording_selection_type recording_selection;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("stream");

static const char* rawData = "\334\000\000\000^\001\000\000k\001\000\000p\001\000\000u\001\000\000\014\002\000\000\015"
  "\002\000\000\021\002\000\000\022\002\000\000\026\002\000\000\027\002\000\000b\003\000\000j\003\000\000\354\004\000"
  "\000\221\005\000\000\310\005\000\000'\006\000\000\232\006\000\000\312\006\000\000[\007\000\000n\007\000\000|\007\000"
  "\000}\007\000\000\240\007\000\000\301\007\000\000\315\007\000\000\357\007\000\000\367\007\000\000\233\010\000\000\235"
  "\010\000\000\236\010\000\000\326\010\000\000\363\010\000\000\364\010\000\000\365\010\000\000N\t\000\000h\t\000\000|\t"
  "\000\000}\t\000\000\203\t\000\000\204\t\000\000\226\t\000\000\261\t\000\000\264\t\000\000\320\t\000\000\323\t\000\000"
  "\324\t\000\000\325\t\000\0003\n\000\000G\n\000\000u\n\000\000x\n\000\000\224\n\000\000\227\n\000\000\230\n\000\000\n<"
  "!DOCTYPE html>\n<html>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n   "
  " <title>VDR Live - </title>\n    \n    \n    \n    <script> window.onbeforeunload = function() { player.stop(); } </s"
  "cript>\n  </head>\n  <body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n    \n    \n    \n    <div class="
  "\"inhalt\">\n      <div class=\"player-container\">\n      <div id=\"player\" class=\"player\">\n\n        <script sr"
  "c=\"https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.min.js\"></script>\n        <script>\n        Clappr.Log.s"
  "etLevel(Clappr.Log.LEVEL_INFO);\n        var player = new Clappr.Player({\n          source: \"media//master_.m3u8\","
  "\n          parentId: \"#player\",\n          width: \"100%\", height: \"100%\",\n          autoPlay: \"true\",\n    "
  "      events: {\n            onError: function(error) { console.log('Calppr.Player error: ', error); player.play(); }"
  ",\n            onEnded: function() { console.log('Clappr.Player ended'); player.play(); },\n          }\n        });"
  "\n        </script>\n      </div>\n      </div>\n      <table class=\"listing streaming\" cellspacing=\"0\" cellpaddi"
  "ng=\"0\">\n        <tbody>\n          <script>\n            document.write(existingRecordingString(1, \"\", ))\n     "
  "     </script>\n        </tbody>\n      </table>\n      <table class=\"listing streaming\" cellspacing=\"0\" cellpadd"
  "ing=\"0\">\n        <tr>\n          \n          <td class=\"topaligned\">\n            <div class=\"withmargin\">\n  "
  "            <div class=\"nomargin nowrap\"></div>\n              <div class=\"progress\"><div></div></div>\n         "
  "   </div>\n          </td>\n          <td class=\"topaligned\" style=\"width: 788px\">\n            <div class=\"more"
  " withmargin\">\n                <a\n              \n              ><span class=\"title\"></span><br /><span class=\"s"
  "hort\"></span></a>\n              <span class=\"title\"></span>\n            </div>\n          </td>\n          <td c"
  "lass=\"topaligned rightcol\" style=\"width: 250px\"><div class=\"station withmargin\"><a  href=\"schedule.html\?chann"
  "elid=\" ></a></div>\n          </td>\n        </tr>\n      </table>\n    </div>\n  </body>\n</html>\n\n\n<form action"
  "=\"stream.html\" method=\"get\" id=\"channels\">\n  <span>\n    <label for=\"channel\">:&nbsp;<span class=\"bold\"></"
  "span></label>\n    \n      \n  </span>\n</form>\n<span class=\"sep\">|</span>\n\302\253 \n<span class=\"sep\">|</span"
  ">\n \302\273\n\n<form action=\"stream.html=\" method=\"get\" id=\"recordings\">\n  <span>\n    <label for=\"recording"
  "\">:&nbsp;</label>\n    \n  </span>\n</form>\n<span class=\"sep\">|</span>\n\302\253 \n<span class=\"sep\">|</span>\n"
  " \302\273\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection"),
    recording_selection(*this, "recording_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel = qparam.get< int >("channel", ( -1));
std::string channelid = qparam.get< std::string >("channelid");
std::string recid = qparam.get< std::string >("recid");
  // </%args>

#line 19 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 20 "stream.ecpp"
  typedef std::string prev_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, prev_recording, ());   // <%session> std::string prev_recording
  _tnt_ignore_unused<prev_recording_type>(prev_recording);
#line 21 "stream.ecpp"
  typedef std::string next_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, next_recording, ());   // <%session> std::string next_recording
  _tnt_ignore_unused<next_recording_type>(next_recording);
#line 22 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( nullptr));   // <%session> FFmpegThread * f_worker( nullptr)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 25 "stream.ecpp"
  typedef const cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(const cChannel*, Channel, ());   // <%request> const cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 26 "stream.ecpp"
  typedef std::string RecId_type;
  TNT_REQUEST_SHARED_VAR(std::string, RecId, ());   // <%request> std::string RecId
  _tnt_ignore_unused<RecId_type>(RecId);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 29 "stream.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat<0> targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }

  pageTitle = trVDR("Stream");

  // check for session cookie.
  std::string session;
  if (request.hasCookie("tntnet")) {
    session = request.getCookie("tntnet");
    dsyslog("vdrlive::stream::session(%s)", session.c_str());
  }
  else {
    esyslog("vdrlive::stream: no session cookie found");
    return reply.redirect("");
  }

  Channel = nullptr;
  std::string url;
  if ( qparam.has("recid") ) {
    RecId = recid.substr( 0, 10 ).compare( "recording_" ) == 0 ? recid.substr( 10 ) : recid;
    const cRecording* Recording = LiveRecordingsManager()->GetByMd5Hash( recid );
    if ( Recording ) {
      struct stat st;
      const char* filename = Recording->FileName();
      if ( filename && stat( filename, &st ) == 0  ) {
        char buffer[50];  // suitable for accommodating url with 2x ULLONG_MAX
        int length = snprintf( buffer, sizeof( buffer ), "%lu:%llu.rec", ( unsigned long )st.st_dev, ( unsigned long long )st.st_ino );
        if ( 0 < length && length < ( int )sizeof( buffer ) ) {
          url += buffer;
          tChannelID cid = Recording->Info()->ChannelID();
          LOCK_CHANNELS_READ;
          Channel = Channels->GetByChannelID( cid );
        }
      }
    }
    if ( !Channel )
      throw HtmlError( tr("Couldn't find recording or no recordings available. Maybe you mistyped your request?") );
  } else {
    LOCK_CHANNELS_READ;
    if ( qparam.has("channelid") ) {
      tChannelID cid = cid.FromString(channelid.c_str());
      Channel = Channels->GetByChannelID( cid );
    } else if ( channel > 0 ) {
      LOCK_CHANNELS_READ;
      Channel = Channels->GetByNumber( channel );
    } else if (cDevice::CurrentChannel()) {
      Channel = Channels->GetByNumber(cDevice::CurrentChannel());
    } else {
      Channel = Channels->Get( Channels->GetNextNormal( -1 ) );
    }
    if ( !Channel )
      throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );
    channel = Channel->Number();
    channelid = *Channel->GetChannelID().ToString();
    url += Channel->GetChannelID().ToString();
  }

  url += ".";
  for ( auto c : LiveSetup().GetStreamdevType() )
    url += std::tolower( c );
  dsyslog("vdrlive::stream::vtype(%d)", Channel->Vtype());
  dsyslog("vdrlive::stream::f_worker(%p)", f_worker);
  if ( !f_worker) {
    f_worker = new FFmpegThread();
    dsyslog("vdrlive::stream: new FFmpegThread created");
  }

  switch( Channel->Vtype() ) {
    case 27: // h264
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingH264 : tagChannelH264);
      break;
    case 36: // h265
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingHVEC : tagChannelHVEC);
      break;
    case 2: // mpeg2
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingMPG2 : tagChannelMPG2);
      break;
    default: // others
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingDFLT : tagChannelDFLT);
  }
  dsyslog("vdrlive::stream::StartFFmpeg(%s)", url.c_str());


  reply.out() << _tntChunks[0]; // \n<!DOCTYPE html>\n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR Live - 
#line 121 "stream.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 122 "stream.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 122 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 123 "stream.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 123 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 124 "stream.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 124 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    <script> window.onbeforeunload = function() { player.stop(); } </script>\n  </head>\n  <body onload="adjustHeader()" onresize="adjustHeader()">\n    
  // <& pageelems.logo ...
  { 
#line 128 "stream.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 128 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n
#line 129 "stream.ecpp"
  if ( qparam.has("recid") ) {

  reply.out() << _tntChunks[6]; //     
  // <& menu ...
  { 
#line 130 "stream.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 130 "stream.ecpp"
    _tnt_cq4.add( "active", ("stream"));
#line 130 "stream.ecpp"
    _tnt_cq4.add( "component", ("stream.recording_selection"));
#line 130 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n
#line 131 "stream.ecpp"
  } else {

  reply.out() << _tntChunks[8]; //     
  // <& menu ...
  { 
#line 132 "stream.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 132 "stream.ecpp"
    _tnt_cq5.add( "active", ("stream"));
#line 132 "stream.ecpp"
    _tnt_cq5.add( "component", ("stream.channel_selection"));
#line 132 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[9]; // \n
#line 133 "stream.ecpp"
  }

  reply.out() << _tntChunks[10]; //     <div class="inhalt">\n      <div class="player-container">\n      <div id="player" class="player">\n\n        <script src="https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.min.js"></script>\n        <script>\n        Clappr.Log.setLevel(Clappr.Log.LEVEL_INFO);\n        var player = new Clappr.Player({\n          source: "media/
#line 142 "stream.ecpp"
  reply.sout() << ( session );
  reply.out() << _tntChunks[11]; // /master_
#line 142 "stream.ecpp"
  reply.sout() << ( url );
  reply.out() << _tntChunks[12]; // .m3u8",\n          parentId: "#player",\n          width: "100%", height: "100%",\n          autoPlay: "true",\n          events: {\n            onError: function(error) { console.log('Calppr.Player error: ', error); player.play(); },\n            onEnded: function() { console.log('Clappr.Player ended'); player.play(); },\n          }\n        });\n        </script>\n      </div>\n      </div>\n
#line 154 "stream.ecpp"

if (qparam.has("recid")) {
dsyslog("vdrlive::stream: generating recording info");
RecordingsItemRecPtr rPtr = LiveRecordingsManager()->GetByIdHash( recid );
cToSvConcat<0> recording_item;
rPtr->AppendAsJSArray(recording_item);

  reply.out() << _tntChunks[13]; //       <table class="listing streaming" cellspacing="0" cellpadding="0">\n        <tbody>\n          <script>\n            document.write(existingRecordingString(1, "", 
#line 164 "stream.ecpp"
  reply.out() << ( recording_item.c_str() );
  reply.out() << _tntChunks[14]; // ))\n          </script>\n        </tbody>\n      </table>\n
#line 168 "stream.ecpp"

} else {
dsyslog("vdrlive::stream: generating EPG info");
const cSchedule *Schedule = NULL;
{
  LOCK_SCHEDULES_READ;
  Schedule = Schedules->GetSchedule(Channel);
}
const cEvent *Event = NULL;
if (Schedule)
  Event = Schedule->GetPresentEvent();

EpgInfoPtr epgEvent;
if (Event) {
  epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);

  tChannelID chanId;
  tEventID eventId;
  EpgEvents::DecodeDomId(epgEvent->Id(), chanId, eventId);
  char const * timeFormat = tr("%I:%M %p");
  char const * dateFormat = tr("%A, %x");
  std::string headTime = std::string(cToSvDateTime(timeFormat, time(0)));
  std::string headDate = std::string(cToSvDateTime(dateFormat, time(0)));
  std::string startTime(epgEvent->StartTime(tr("%I:%M %p")));
  std::string endTime(epgEvent->EndTime(tr("%I:%M %p")));
  std::string startDate(epgEvent->StartTime(tr("%a, %x")));

  std::string timeSpan(startTime + " - " + endTime);

  if (startTime.empty() && endTime.empty()) {
    timeSpan = headTime;
    startDate = headDate;
  }
  cToSvConcat longDescription;
  AppendHtmlEscapedAndCorrectNonUTF8(longDescription, StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars()));
  longDescription << "<br/><br/>";
  AppendHtmlEscapedAndCorrectNonUTF8(longDescription, tr("Click to view details."));

  
  reply.out() << _tntChunks[15]; //       <table class="listing streaming" cellspacing="0" cellpadding="0">\n        <tr>\n          
  // <& pageelems.epg_tool_box ...
  { 
#line 209 "stream.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 209 "stream.ecpp"
    _tnt_cq6.add( "detail", (0));
#line 209 "stream.ecpp"
    _tnt_cq6.add( "endTime", (epgEvent->GetEndTime()));
#line 209 "stream.ecpp"
    _tnt_cq6.add( "epgid", (epgEvent->Id()));
#line 209 "stream.ecpp"
    _tnt_cq6.add( "lastCurrentChanel", (0));
#line 209 "stream.ecpp"
    _tnt_cq6.add( "startTime", (epgEvent->GetStartTime()));
#line 209 "stream.ecpp"
    _tnt_cq6.add( "title", (epgEvent->Title()));
#line 209 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[16]; // \n          <td class="topaligned">\n            <div class="withmargin">\n              <div class="nomargin nowrap">
#line 212 "stream.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[17]; // </div>\n              <div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 213 "stream.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 213 "stream.ecpp"
    _tnt_cq7.add( "duration", (epgEvent->Duration()));
#line 213 "stream.ecpp"
    _tnt_cq7.add( "progress", (epgEvent->Elapsed()));
#line 213 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[18]; // </div></div>\n            </div>\n          </td>\n          <td class="topaligned" style="width: 788px">\n            <div class="more withmargin">\n
#line 218 "stream.ecpp"
            if (eventId != 0) {

  reply.out() << _tntChunks[19]; //                 <a\n
#line 220 "stream.ecpp"
              if (!longDescription.empty()) {

  reply.out() << _tntChunks[20]; //               
  // <& tooltip.hint ...
  { 
#line 221 "stream.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 221 "stream.ecpp"
    _tnt_cq8.add( "text", (longDescription));
#line 221 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 221 "stream.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 221 "stream.ecpp"
    _tnt_cq9.add( "domId", (epgEvent->Id()));
#line 221 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[21]; // \n
#line 222 "stream.ecpp"
              }

  reply.out() << _tntChunks[22]; //               ><span class="title">
#line 223 "stream.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[23]; // </span><br /><span class="short">
#line 223 "stream.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[24]; // </span></a>\n
#line 224 "stream.ecpp"
              } else {

  reply.out() << _tntChunks[25]; //               <span class="title">
#line 225 "stream.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[26]; // </span>\n
#line 226 "stream.ecpp"
              }

  reply.out() << _tntChunks[27]; //             </div>\n          </td>\n          <td class="topaligned rightcol" style="width: 250px"><div class="station withmargin"><a  href="schedule.html\?channelid=
#line 229 "stream.ecpp"
  reply.sout() << ( channelid );
  reply.out() << _tntChunks[28]; // " 
  // <& tooltip.hint ...
  { 
#line 229 "stream.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 229 "stream.ecpp"
    _tnt_cq10.add( "text", (tr("View the schedule of this channel")));
#line 229 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[29]; // >
#line 229 "stream.ecpp"
  reply.sout() << ( cSv(cToSvInt(channel)) );
#line 229 "stream.ecpp"
  reply.sout() << ( tr(" - ") );
#line 229 "stream.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << _tntChunks[30]; // </a></div>\n          </td>\n        </tr>\n      </table>\n
#line 233 "stream.ecpp"
} // if (Event)

#line 234 "stream.ecpp"
} // if ( qparam.has("recid")

  reply.out() << _tntChunks[31]; //     </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[32]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[33]; // \n
  reply.out() << _tntChunks[46]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream::channel_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 19 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 20 "stream.ecpp"
  typedef std::string prev_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, prev_recording, ());   // <%session> std::string prev_recording
  _tnt_ignore_unused<prev_recording_type>(prev_recording);
#line 21 "stream.ecpp"
  typedef std::string next_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, next_recording, ());   // <%session> std::string next_recording
  _tnt_ignore_unused<next_recording_type>(next_recording);
#line 22 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( nullptr));   // <%session> FFmpegThread * f_worker( nullptr)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 25 "stream.ecpp"
  typedef const cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(const cChannel*, Channel, ());   // <%request> const cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 26 "stream.ecpp"
  typedef std::string RecId_type;
  TNT_REQUEST_SHARED_VAR(std::string, RecId, ());   // <%request> std::string RecId
  _tnt_ignore_unused<RecId_type>(RecId);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[34]; // <form action="stream.html" method="get" id="channels">\n  <span>\n    <label for="channel">
#line 243 "stream.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[35]; // :&nbsp;<span class="bold">
#line 243 "stream.ecpp"
  reply.sout() << ( cSv(cToSvInt(Channel->Number())) );
  reply.out() << _tntChunks[36]; // </span></label>\n    
  // <& channels_widget ...
  { 
#line 244 "stream.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 244 "stream.ecpp"
    _tnt_cq11.add( "name", ("channel"));
#line 244 "stream.ecpp"
    _tnt_cq11.add( "onchange", ("player.stop(); document.forms.channels.submit()"));
#line 244 "stream.ecpp"
    _tnt_cq11.add( "selected", (Channel ? *Channel->GetChannelID().ToString() : ""));
#line 244 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[37]; // \n
#line 245 "stream.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[38]; //       
  // <& pageelems.ajax_action_href ...
  { 
#line 246 "stream.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 246 "stream.ecpp"
    _tnt_cq12.add( "action", "switch_channel");
#line 246 "stream.ecpp"
    _tnt_cq12.add( "alt", "");
#line 246 "stream.ecpp"
    _tnt_cq12.add( "image", "zap.png");
#line 246 "stream.ecpp"
    _tnt_cq12.add( "param", (Channel->GetChannelID()));
#line 246 "stream.ecpp"
    _tnt_cq12.add( "tip", (tr("Switch to this channel.")));
#line 246 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[39]; // \n
#line 247 "stream.ecpp"
   }

  reply.out() << _tntChunks[40]; //   </span>\n</form>\n
#line 250 "stream.ecpp"

    int maxChannelNumber;
    {  LOCK_CHANNELS_READ;
       maxChannelNumber = Channels->MaxNumber();
    }
    int channelNumber = Channel->Number();
    bool prev = channelNumber > 1;
    bool next = channelNumber < maxChannelNumber;

  reply.out() << _tntChunks[41]; // <span class="sep">|</span>\n
#line 260 "stream.ecpp"
  if ( prev )
    reply.out() <<  "<a href=\"stream.html?channel=" << channelNumber - 1 << "\">" ;
  reply.out() << _tntChunks[42]; // \302\253 
#line 260 "stream.ecpp"
  reply.sout() << ( tr("Prev. entry") );
#line 260 "stream.ecpp"
  if ( prev )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[43]; // \n<span class="sep">|</span>\n
#line 262 "stream.ecpp"
  if ( next )
    reply.out() <<  "<a href=\"stream.html?channel=" << channelNumber + 1 << "\">" ;
#line 262 "stream.ecpp"
  reply.sout() << ( tr("Next entry") );
  reply.out() << _tntChunks[44]; //  \302\273
#line 262 "stream.ecpp"
  if ( next )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[45]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recording_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream::recording_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 19 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 20 "stream.ecpp"
  typedef std::string prev_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, prev_recording, ());   // <%session> std::string prev_recording
  _tnt_ignore_unused<prev_recording_type>(prev_recording);
#line 21 "stream.ecpp"
  typedef std::string next_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, next_recording, ());   // <%session> std::string next_recording
  _tnt_ignore_unused<next_recording_type>(next_recording);
#line 22 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( nullptr));   // <%session> FFmpegThread * f_worker( nullptr)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 25 "stream.ecpp"
  typedef const cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(const cChannel*, Channel, ());   // <%request> const cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 26 "stream.ecpp"
  typedef std::string RecId_type;
  TNT_REQUEST_SHARED_VAR(std::string, RecId, ());   // <%request> std::string RecId
  _tnt_ignore_unused<RecId_type>(RecId);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[47]; // <form action="stream.html=" method="get" id="recordings">\n  <span>\n    <label for="recording">
#line 268 "stream.ecpp"
  reply.sout() << ( tr("Recording") );
  reply.out() << _tntChunks[48]; // :&nbsp;</label>\n    
  // <& recordings_widget ...
  { 
#line 269 "stream.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 269 "stream.ecpp"
    _tnt_cq13.add( "name", ("recid"));
#line 269 "stream.ecpp"
    _tnt_cq13.add( "onchange", ("player.stop(); document.forms.recordings.submit()"));
#line 269 "stream.ecpp"
    _tnt_cq13.add( "selected", (RecId));
#line 269 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "recordings_widget"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[49]; // \n  </span>\n</form>\n<span class="sep">|</span>\n
#line 273 "stream.ecpp"
  if ( !prev_recording.empty() )
    reply.out() <<  "<a href=\"stream.html?recid=recording_" << prev_recording << "\">" ;
  reply.out() << _tntChunks[50]; // \302\253 
#line 273 "stream.ecpp"
  reply.sout() << ( tr("Prev. entry") );
#line 273 "stream.ecpp"
  if ( !prev_recording.empty() )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[51]; // \n<span class="sep">|</span>\n
#line 275 "stream.ecpp"
  if ( !next_recording.empty() )
    reply.out() <<  "<a href=\"stream.html?recid=recording_" << next_recording << "\">" ;
#line 275 "stream.ecpp"
  reply.sout() << ( tr("Next entry") );
  reply.out() << _tntChunks[52]; //  \302\273
#line 275 "stream.ecpp"
  if ( !next_recording.empty() )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[53]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
