////////////////////////////////////////////////////////////////////////
// content.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.content")

// <%pre>
#line 1 "content.ecpp"


#include <setup.h>
#include <filecache.h>
#include <tntfeatures.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("content");

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("content " << qparam.getUrl());


#line 11 "content.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 13 "content.ecpp"

std::string mime("image/png");
if (request.getArgsCount() > 0) {
#if TNT_MAPURL_NAMED_ARGS
  mime = request.getArg("mime-type");
#else
  mime = request.getArg(0);
#endif
  // dsyslog("vdrlive::content found mime arg (%s)", mime.c_str());
}
reply.setContentType(mime);
// dsyslog("vdrlive::content::mimetype(%s)", mime.c_str());

std::string const path(request.getPathInfo());
// dsyslog("vdrlive::content: path = %s", path.c_str());

// security checking of path. In order to not allow exploits the
// path must be absolute and not contain any upward references (e.g '../')
if (path.empty()) {
  return HTTP_BAD_REQUEST;
}
if ('/' != path[0]) {
  return HTTP_BAD_REQUEST;
}
if (std::string::npos != path.find("../", 1)) {
  return HTTP_BAD_REQUEST;
}

FileCache::ptr_type f = LiveFileCache().get(path);

if (f.get() == 0) {
  // dsyslog("vdrlive::content: DECLINED");
  return DECLINED;
}
std::string ctime = tnt::HttpMessage::htdate(f->ctime());
std::string browserTime = request.getHeader(tnt::httpheader::ifModifiedSince);
if (browserTime == ctime) {
  // dsyslog("vdrlive::content: HTTP_NOT_MODIFIED");
  return HTTP_NOT_MODIFIED;
}

// dsyslog("vdrlive::content: send %d bytes of data", f->size());
reply.setHeader(tnt::httpheader::lastModified, ctime);
reply.out().write(f->data(), f->size());

  // <%/cpp>
  return DEFAULT;
}

} // namespace
